//+------------------------------------------------------------------+
//|                                  accurateMACD_x4Alerts_trial.mq4 |
//|                                              Copyright 2013, Mao |
//|                                          mail_to_mao@yahoo.co.jp |
//+------------------------------------------------------------------+
// This indicator is a modified version of "Good_Macd.mq4"
// 4 Alerts (crossArrow, soundAlert, panelAlert and emailAlert) were added
// to the above indicator.

#property copyright "Copyright  2013, Mao"

/* sȓ_܂火܂ */
#property link  "http://mb1.net4u.org/bbs/ciao_mao/trees"


#define indiHead  "accurateMACD_x4Alerts_trial"

#property indicator_separate_window
#property indicator_buffers 6

#property indicator_color1 Teal
#property indicator_width1 1

#property indicator_color2 Red
#property indicator_width2 1
#property indicator_style2 2

#property indicator_color3 C'135,41,41'
#property indicator_width3 3

#property indicator_color4 C'0,77,0'
#property indicator_width4 3

#property indicator_color5 DeepPink
#property indicator_width5 1

#property indicator_color6 Lime
#property indicator_width6 1

#property indicator_levelcolor C'30,30,30'
#property indicator_levelstyle 0
#property indicator_level1 0

  //---- input parameters
  extern string Parameter1="//--------------------------------";
  extern int fastPeriod  =12;
  extern int slowPeriod  =26;
  extern int signalPeriod=9;
  
  extern string Parameter2="//--------------------------------";
  extern bool showHisto=true;
  extern bool showDot=true;
  extern int alertBarNum=1;   // O  ŐVo[[0] ŃA[gAP  mo[[1]ŃA[g
  
  extern string Parameter3="//--------------------------------";
  extern bool soundAlert=true;
  extern bool panelAlert=true;
  extern bool emailAlert=false;
  extern color paraColor=Yellow;   // C'100,96,45';
  
  //---- buffers
  double macdBuff[], signalBuff[], upHist[], dnHist[];
  double upArrow[], dnArrow[];
  
  //---- variables
  double alpha=0;
  double alpha_1=0;
  
  string timeFrame;
  string short_name;
  int swNum;

  
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  //---- name for DataWindow and indicator subwindow label
  short_name=indiHead+" ("+fastPeriod+", "+slowPeriod+", "+signalPeriod+")";
  IndicatorShortName(short_name);

  IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+1);
  
  switch(Period())
    {
    case 1     : timeFrame="M1" ; break;
    case 5     : timeFrame="M5" ; break;
    case 15    : timeFrame="M15"; break;
    case 30    : timeFrame="M30"; break;
    case 60    : timeFrame="H1" ; break;
    case 240   : timeFrame="H4" ; break;
    case 1440  : timeFrame="D1" ; break;
    case 10080 : timeFrame="W1" ; break;
    case 43200 : timeFrame="MN1"; break;
    }
  
  //---- indicators
  int buffNo=0;
    SetIndexLabel(buffNo,"MACD"); SetIndexStyle(buffNo,DRAW_LINE);
    SetIndexBuffer(buffNo,macdBuff); SetIndexDrawBegin(buffNo,slowPeriod);
  
  buffNo=1;
    SetIndexLabel(buffNo,"Signal"); SetIndexStyle(buffNo,DRAW_LINE,STYLE_DOT);
    SetIndexBuffer(buffNo,signalBuff); SetIndexDrawBegin(buffNo, slowPeriod+signalPeriod);
  
  buffNo=2;
    SetIndexLabel(buffNo,"upHist"); SetIndexStyle(buffNo, DRAW_HISTOGRAM);
    SetIndexBuffer(buffNo, upHist); SetIndexDrawBegin(buffNo, slowPeriod+signalPeriod);
  
  buffNo=3;
    SetIndexLabel(buffNo,"dnHist"); SetIndexStyle(buffNo, DRAW_HISTOGRAM);
    SetIndexBuffer(buffNo, dnHist); SetIndexDrawBegin(buffNo, slowPeriod+signalPeriod);

  buffNo=4;
    SetIndexLabel (buffNo, NULL); SetIndexStyle(buffNo, DRAW_ARROW); SetIndexArrow(buffNo, 159);
    SetIndexBuffer(buffNo, upArrow); SetIndexDrawBegin(buffNo, slowPeriod+signalPeriod);
  
  buffNo=5;
    SetIndexLabel (buffNo, NULL); SetIndexStyle(buffNo, DRAW_ARROW); SetIndexArrow(buffNo, 159);
    SetIndexBuffer(buffNo, dnArrow); SetIndexDrawBegin(buffNo, slowPeriod+signalPeriod);

  //----
	alpha=2.0/(signalPeriod+1.0);
	alpha_1=1.0-alpha;
  //----
  
  return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  //---- 
  // ObjectDelete(indiHead+"_alertBarNum");
  // ObjectDelete(indiHead+"_alertsStatus");

  //----
  return(0);
  }
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  int limit;
  int counted_bars = IndicatorCounted();
  //---- check for possible errors
  if(counted_bars<0) return(-1);
  //---- last counted bar will be recounted
  if(counted_bars>0) counted_bars--;
  limit=Bars-counted_bars;
  
  //---- initial zero
  if(counted_bars<1)
    {
    swNum=WindowFind(short_name);
    if(swNum==-1) swNum=WindowsTotal(); 
    }
    
      
  for(int i=limit; i>=0; i--)
    {
    macdBuff[i]=iMA(NULL, 0, fastPeriod, 0, MODE_EMA, PRICE_CLOSE, i)
               -iMA(NULL, 0, slowPeriod, 0, MODE_EMA, PRICE_CLOSE, i);
    signalBuff[i]=alpha*macdBuff[i]+alpha_1*signalBuff[i+1];
    
    if(showHisto)
      {
      upHist[i]=EMPTY_VALUE; dnHist[i]=EMPTY_VALUE;
      double curMACD=macdBuff[i]-signalBuff[i];
      if(curMACD>=0) upHist[i]=curMACD;
      else if(curMACD<0) dnHist[i]=curMACD;
      }
    
    if(showDot)
      {
      int j=i+alertBarNum;
      upArrow[j]=EMPTY_VALUE; dnArrow[j]=EMPTY_VALUE;
      if(signalBuff[j+1]>macdBuff[j+1] && signalBuff[j]<macdBuff[j])
        {
        upArrow[j]=signalBuff[j];   // -arrowPosiAdjust;
        }
      else if(signalBuff[j+1]<macdBuff[j+1] && signalBuff[j]>macdBuff[j])
        {
        dnArrow[j]=signalBuff[j];   // +arrowPosiAdjust;
        }
      }
    
    }   // for_Loop End
  
  //----------------------------------------------------------------------------------------------|


  return(0);
  }
  

